CTParameter< T > Class Template Reference
Command line and parameter parsing

Generic type of a complex paramter. More...

`#include <mia/core/parameter.hh>`

Inheritance diagram for CTParameter< T >:
[legend]
Collaboration diagram for CTParameter< T >:
[legend]

## Public Member Functions

| CTParameter (T &value, bool required, const char *descr)
Public Member Functions inherited from CParameter
void | add_dependend_handler (HandlerHelpMap &handler_map) const
| CParameter (const char type[], bool required, const char *descr)
void | descr (std::ostream &os) const
std::string | get_default_value () const
const char * | get_descr () const
void | get_help_xml (CXMLElement &root) const
std::string | get_value_as_string () const
virtual void | post_set ()
bool | required_set () const
void | reset ()
bool | set (const std::string &str_value)
const char * | type () const
void | value (std::ostream &os) const
virtual | ~CParameter ()

## Protected Member Functions

virtual void | do_descr (std::ostream &os) const
Protected Member Functions inherited from CParameter
void | add_xmlhelp_attribute (CXMLElement &node, const std::string &tag, const std::string &value) const
CXMLElement & | add_xmlhelp_childnode (CXMLElement &parent, const std::string &tag) const
void | add_xmlhelp_text (CXMLElement &node, const std::string &value) const
const std::string | errmsg (const std::string &err_value) const
| create an error message by using the given value that raises the error

## Detailed Description

template<typename T>
class CTParameter< T >

Generic type of a complex paramter.

The (templated) typed parameter. There needs to be defined an operator << (istream& is, T& x) for the do_set method to work.

Definition at line 170 of file parameter.hh.

## Constructor & Destructor Documentation

## CTParameter()

template<typename T>

CTParameter< T >::CTParameter | ( | T & | value,
|  | bool | required,
|  | const char * | descr )

Constructor

Parameters

  value | reference to the parameter handled by this parameter object
  required | set to true if the parameter has to be set by the user
  descr | a description of the parameter

## Member Function Documentation

## do_descr()

template<typename T>

virtual void CTParameter< T >::do_descr | ( | std::ostream & | os | ) | const

protected virtual

the implementation of the description-function

Implements CParameter.

Reimplemented in TBoundedParameter< T >, TBoundedParameter< double >, TBoundedParameter< float >, TBoundedParameter< int16_t >, TBoundedParameter< int32_t >, TBoundedParameter< int64_t >, TBoundedParameter< std::vector< double > >, TBoundedParameter< std::vector< float > >, TBoundedParameter< std::vector< int16_t > >, TBoundedParameter< std::vector< int32_t > >, TBoundedParameter< std::vector< int64_t > >, TBoundedParameter< std::vector< uint16_t > >, TBoundedParameter< std::vector< uint32_t > >, TBoundedParameter< std::vector< uint64_t > >, TBoundedParameter< uint16_t >, TBoundedParameter< uint32_t >, and TBoundedParameter< uint64_t >.

The documentation for this class was generated from the following file:

- parameter.hh